=== Examples/CustomApplications/CMakeLists.txt ===
IF(PARAVIEW_BUILD_QT_GUI)
  ADD_SUBDIRECTORY(ParticlesViewer)
  ADD_SUBDIRECTORY(Spreadsheet)
  ADD_SUBDIRECTORY(Demo0)
  ADD_SUBDIRECTORY(Demo1)
  ADD_SUBDIRECTORY(Clone1)
  ADD_SUBDIRECTORY(Clone2)
ENDIF(PARAVIEW_BUILD_QT_GUI)
