=== debian/changelog ===
paraview (3.10.1-6) unstable; urgency=low

  [ Mathieu Malaterre ]
  * [948a543] Changes to d/control:
              - remove chrpath not required anymore from B-D.
              - remove libgl2ps0 from B-D.
              - update version for libavformat-dev (libav transition).
              - remove qt4-dev-tools from paraview client package recommends.
              - paraview-dev is any not all.
              - add XB-Python-Version to paraview-python.
  * [34c442d] d/rules changes:
              - Add --parallel flags.
              - Remove -lXt from global C*FLAGS.
              - Add doc for CMAKE_SKIP_RPATH value to OFF.
              - Explicitly set MPI libs values.
              - Activate AdiosReader & EyeDomeLighting plugin.
  * [ddb7bf9] Remove BUILDDIR in debian/rules for simplification.
  * [c08591a] *.install files: shuffle things to split into client and
              dev package. (Closes: #640195)
  * [b8874d3] Fix building of vtkXdmf: missing -lXt on link line.
  * [c80f0f3] Import patch from VTK to remove sqlite.
  * [ff19b7e] Split documentation into qch and HTML. Fix lintian reports.
  * [16bdc77] Fix issue with kwProcessXML. (Closes: #640305)
  * [f3d92a5] Add patch for installing html doc.

  [ Anton Gladky ]
  * [6d6c88a] Use DEP-3 for patches.
  * [b952a7a] Add lintian-overrides for paraview-python.
  * [c8bfc6a] Move html-docs into paraview-doc.
  * [3b774f5] Reshuffle manpages according to binaries.

 -- Anton Gladky <gladky.anton@gmail.com>  Thu, 15 Sep 2011 22:13:23 +0200

paraview (3.10.1-5) unstable; urgency=low

  * [c75b9bf] Fix FTBFS with libav/0.7.1. 
    Thanks to Moritz Mühlenhoff <jmm@inutil.org>. (Closes: #638246)

 -- Anton Gladky <gladky.anton@gmail.com>  Sat, 03 Sep 2011 19:34:04 +0200

paraview (3.10.1-4) unstable; urgency=low

  * [cb824b2] Revert hurd-i386 restriction, because it does not help to 
              resolve BD-problems for this platform.
  * [2e250a5] Use packaged-HDF5. Hopefully fixes FTBFS on mipsel and sparc.

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 31 Aug 2011 18:01:19 +0200

paraview (3.10.1-3) unstable; urgency=low

  * [e5cb2e3] Put pvpython, vtkWrapPython, vtkWrapPythonInit into 
              paraview-python binary. (Closes: #637397)
  * [0dd738f] Remove mpi-default-dev from BD for hurd-i386. Hopefully 
              fixes FTBFS on this platform.
  * [2293398] Add gl2ps library and headers to BD. VTK_USE_SYSTEM_GL2PS 
              is on (should use system`s gl2ps-library). (Closes: #638797)
  * [8696bbf] Make paraview-python arch-dependend because of binaries.
  * [9e50716] Add ${shlibs:Depends} to depends of paraview-python.

 -- Anton Gladky <gladky.anton@gmail.com>  Sun, 28 Aug 2011 09:33:24 +0200

paraview (3.10.1-2) unstable; urgency=low

  * [27f6ded] Split paraview into paraview and paraview-python. 
              (Closes: #637397)
  * [ea0f0df] Add paraview-python in "Recommends" section of paraview.
  * [19d9bc5] Fix FTBFS on KFreeBSD, changing -std=c99 parameter on -std=gnu99.
  * [25e3fe9] Fix BD-problem on hurd-i386, deleting libhdf5-mpi-dev from BD.
  * [f9c008d] Make paraview-python and paraview-doc architecture independent.

 -- Anton Gladky <gladky.anton@gmail.com>  Sat, 13 Aug 2011 15:49:29 +0200

paraview (3.10.1-1) unstable; urgency=low

  [ Mathieu Malaterre ]
  * [a111d9b] Fix compilation on gcc 4.6. (Closes: #625055) 

  [ Anton Gladky ]
  * [e88f820] Imported Upstream version 3.10.1. (Closes: #619270) 
  * [4e6920c] Switch to 3.0 (quilt).
  * [f94868b] Update build-depends.
  * [b407944] Switch to Standards-Version: 3.9.2 (no changes).
  * [03177f7] Switch to dh 7.
  * [63c1c38] Change VCS-fields to git.
  * [82dd5e9] Enable Ogg/Theora. (Closes: #616549)
  * [0cc8ce1] Divide binary-library and development files. (Closes: #528615)
  * [42b2c6b] Fix lintian warning in control-file.
  * [6d564e4] Add paraview-doc binary. Rename libparaview-dev to 
      paraview-dev. (Closes: #587504)
  * [7516e41] Add .links file to prevent images file being in /usr/lib.
  * [88a5551] Fix warnings in manpages.
  * [729c6cf] Add myself to uploaders.
  * [41db40f] Add lintian-overrides to block unresolvable errors.
  * [a0d65b4] Enable python-support. (Closes: #576837)
  * [5c7c089] Install .desktop and .pixmap files with .install. 
      (Closes: #595683)
  * [5c7c089] Switch hardcoded install of python-files to more 
      reliable dh_python2. (Closes: #585267)

 -- Anton Gladky <gladky.anton@gmail.com>  Tue, 26 Jul 2011 00:37:47 +0200

paraview (3.8.1-3) unstable; urgency=low

  * Fix compilation with FFMPEG (Closes: #614471)
  * Package contains final 3.8.1 source (Closes: #611840)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Fri, 25 Feb 2011 14:32:09 +0100

paraview (3.8.1-2) unstable; urgency=low

  * Team upload
  * Fix a merge error in the description of the package. (Closes: #600993)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 27 Oct 2010 20:23:33 +0200

paraview (3.8.1-1) unstable; urgency=low

  * New upstream: 3.8.1. Closes: #591137
  * Do not install system lib (ffmpeg, qt)
  * Update Standard-Version: 3.9.1 (no change required)
  * Some debian/rules cleanups

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Fri, 30 Jul 2010 11:56:30 +0200

paraview (3.8.0-1) unstable; urgency=low

  * New upstream
  * Update debian control to 3.9.0

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Mon, 05 Jul 2010 17:05:12 +0200

paraview (3.6.2-5) unstable; urgency=low

  * Building MySQL and PostreSQL for consistency with VTK
    This will be needed for OverView
  * Fix watch file to only check release (even number).
  * Fix compilation on armel. Closes: #587712
  * Use virtual package for jpeg, tiff, png & expat

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Thu, 01 Jul 2010 04:33:09 +0200

paraview (3.6.2-4) unstable; urgency=low

  * Adding myself to maintainers.
  * Fix FTBFS with boost 1.42. Closes: #580974
  * Fix vtkPVPluginInit.cxx.in installation. Closes: #580959

